<?php
namespace BricksUltimate\Elements;

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

use BricksUltimate\{Helpers, WooCommerce};

class WooBillTo extends \Bricks\Element {
	public $category = 'checkout';
	public $name 	= 'bu-billing-to';
	public $icon 	= 'ti-layout-list-post';
	//public $scripts = [ 'buCheckout' ];
	public $nestable = true;

	// Return localized element label
	public function get_label() {
		return esc_html__( '(BU)Billing', 'bricksultimate' );
	}

	// Set builder controls
	public function set_controls() {
	}

	// Render element HTML
	public function render() {
		$settings = $this->settings;

		echo "<{$this->tag} {$this->render_attributes('_root')}>";
		$children = \Bricks\Frontend::render_children( $this );
		?>
		<ul id="bu-billing-option" class="bu-billing-option">
			<li>
				<div class="bu-billing-option-wrapper">
					<input type="radio" name="bill_to_different_address" data-index="0" id="billing_same_as_shipping_radio" value="same_as_shipping" class="billing_option" checked="checked"><label for="billing_same_as_shipping_radio">Same as shipping address</label>
				</div>
			</li>
			<li>
				<div class="bu-billing-option-wrapper">
					<input type="radio" name="bill_to_different_address" data-index="1" id="billing_diff_from_shipping_radio" value="diff_from_shipping" class="billing_option"><label for="billing_diff_from_shipping_radio">Use a different billing address</label>
				</div>
				<div class="bu-billing-form-fields screen-reader-text"><?php echo $children; ?></div>
			</li>
		</ul>
		<?php
		echo "</{$this->tag}>";
	}

	public static function render_builder() { ?>
		<script type="text/x-template" id="tmpl-bricks-element-bu-billing-to">
			<component :is="tag">
				<ul id="bu-billing-option" class="bu-billing-option">
					<li>
						<div class="bu-billing-option-wrapper">
							<input type="radio" name="bill_to_different_address" data-index="0" id="billing_same_as_shipping_radio" value="same_as_shipping" class="billing_option" checked="checked"><label for="billing_same_as_shipping_radio">Same as shipping address</label>
						</div>
					</li>
					<li>
						<div class="bu-billing-option-wrapper">
							<input type="radio" name="bill_to_different_address" data-index="1" id="billing_diff_from_shipping_radio" value="diff_from_shipping" class="billing_option"><label for="billing_diff_from_shipping_radio">Use a different billing address</label>
						</div>
						<div class="bu-billing-form-fields">
							<bricks-element-children :element="element" />
						</div>
					</li>
				</ul>
			</component>
		</script>
	<?php
	}
}